#include "OmHeaders.h"

// Destructor.
OmCommentCollector::~OmCommentCollector()
{
  for (unsigned int index=0; index<comments_.size(); ++index)
    {
      delete comments_[index];
    }
}

// Read comments from an input until there is no more.
void OmCommentCollector::collect(OmInputDevice & input_in)
{
  OmType type;
  input_in.readType(type);
  while (type==OmCommentType)
    {
      OmComment * comment = new OmComment;
      comment->read(input_in);
      comments_.push_back(comment);
      input_in.readType(type);
    }
}

// Transfer the collected comments to a node.
OmNode * OmCommentCollector::uncollect(OmNode * node_in)
{
  OmException::checkNullPointer(node_in);

  node_in->comments_.insert(node_in->comments_.begin(), comments_.begin(), comments_.end());
  comments_.clear();
  return node_in;
}
