#include "OmHeaders.h"

// Translate the carried information explaining the situation.
const char * OmException::translate(short verbose_in)
{
  // Incremental enrichissement based on verbosity

  // Verbose >= 0
  if (verbose_in>=0)
    {
      translation_ = "";
    }

  // Verbose >= 1
  if (verbose_in>=1)
    {
      switch (type_)
	{
	case UnsupportedBase : translation_ += "Unsupported base for big integers (must be 10 or 16)"; break;
	case FileError       : translation_ += "Not a valid file (I/O error)"; break;
	case NotIterating    : translation_ += "Iteration is done (cannot go further)"; break;
	case EmptyString     : translation_ += "Empty string not allowed"; break;
	case Disabled        : translation_ += "Disabled operation"; break;
	case MalformedNode   : translation_ += "Malformed node might be used in certain conditions but cannot be read nor written"; break;
	case NullPointer     : translation_ += "Null pointer not allowed"; break;
	case OutOfRange      : translation_ += "Out of range for index"; break;
	case Underlying      : translation_ += "Underlying error from the C library"; break;
	case Other           : translation_ += "Some error occured (no more information)"; break;
	default              : translation_ += "INVALID ERROR - Verify OmException is good version... and no bad cast"; break;
	}
    }

  // Verbose >= 2
  if (verbose_in>=2)
    {
      if (details_!="")
	{
	  translation_ += " -> ";
	  translation_ += details_;
	}
    }

  // Return
  return translation_.c_str();
}
