#ifndef OM_HEADERS_H
#define OM_HEADERS_H

/**
 * This file includes all needed declarations and definitions for the program.
 * Including this unique file should allow the use of the entire OpenMath C++ library.
 */

// Forward declarations
class OmException;
class OmStream;
class OmOutputStream;
class OmInputStream;
class OmOutputFileStream;
class OmOutputStringStream;
class OmInputFileStream;
class OmInputStringStream;
class OmOutputDevice;
class OmInputDevice;
class OmComment;
class OmCommentCollector;
class OmNode;
class OmFinalNode;
class OmIntegerNode;
class OmBigIntegerNode;
class OmByteArrayNode;
class OmFloatNode;
class OmStringNode;
class OmWStringNode;
class OmSymbolNode;
class OmVariableNode;
class OmPInstructionNode;
class OmApplicationNode;
class OmBindingNode;
class OmErrorNode;
class OmObjectNode;
class OmDocumentNode;

// C++ library
#include <cassert>
#include <cstdio>
#include <list>
#include <string>
#include <vector>

using std::list;
using std::string;
using std::vector;
using std::pair;

// OpenMath C library
#include "OM.h"

// OpenMath C++ library
#include "OmCommon.h"
#include "OmException.h"
#include "OmStream.h"
#include "OmOutputFileStream.h"
#include "OmOutputStringStream.h"
#include "OmInputFileStream.h"
#include "OmInputStringStream.h"
#include "OmOutputDevice.h"
#include "OmInputDevice.h"
#include "OmComment.h"
#include "OmCommentCollector.h"
#include "OmNode.h"
#include "OmFinalNode.h"
#include "OmIntegerNode.h"
#include "OmBigIntegerNode.h"
#include "OmByteArrayNode.h"
#include "OmFloatNode.h"
#include "OmStringNode.h"
#include "OmWStringNode.h"
#include "OmSymbolNode.h"
#include "OmVariableNode.h"
#include "OmPInstructionNode.h"
#include "OmApplicationNode.h"
#include "OmBindingNode.h"
#include "OmErrorNode.h"
#include "OmObjectNode.h"
#include "OmDocumentNode.h"

#endif // OM_HEADERS_H
