#ifndef OM_OUTPUT_STRING_STREAM_H
#define OM_OUTPUT_STRING_STREAM_H

/**
 * Implementation of output stream for strings.
 *
 * This class provides a specialization of OmOutputStream for strings buffers.
 * This corresponds to an encapsulation of I/O operations needed by the library.
 */
class OmOutputStringStream : public OmOutputStream
{
public:
  /**
   * Default constructor.
   */
  OmOutputStringStream() {
    buffer_ = 0;
    setIO(OMmakeIOString(&buffer_)); }

  /**
   * Destructor.
   */
  virtual ~OmOutputStringStream() {
    free(buffer_); }

  /**
   * Get the buffer.
   */
  virtual const char * getBuffer() const {
    return buffer_; }

private:
  char * buffer_;
};

#endif // OM_OUTPUT_STRING_STREAM_H
